## gcc-arm-none-eabi 11.3.rel1

=== debian/changelog ===
gcc-arm-none-eabi (15:11.3.rel1-1) unstable; urgency=medium

  * New upstream version 11.3.rel1

 -- Keith Packard <keithp@keithp.com>  Tue, 11 Oct 2022 10:47:01 -0700

gcc-arm-none-eabi (15:10.3-2021.07-4) unstable; urgency=medium

  * Re-add gcc-arm-none-eabi-source package. (Closes: #999817)

 -- Keith Packard <keithp@keithp.com>  Wed, 17 Nov 2021 08:56:53 -0800
