=== debian/rules ===
--- 
+++ 
@@ -84,15 +84,16 @@
 
 $(unpack_stamp): $(tar_stamp)
 	set -ex; \
-		for patch in debian/patches/[0-9]*.patch; do \
-			echo Applying patch "$$patch"; \
-			patch -p1 < "$$patch"; \
-		done
-	set -ex; \
 		cd $(top_dir)/$(src_dir); \
 		for patch in $(shell cat debian/debian_patches.txt); do \
 			echo Applying patch "$$patch"; \
 			patch -p2 < $(gcc_dir)/patches/$$patch; \
+		done
+	set -ex; \
+		cd gcc-*; \
+		for patch in ../debian/patches/[0-9]*.patch; do \
+			echo Applying patch "$$patch"; \
+			patch -p1 < "$$patch"; \
 		done
 	touch $@
