## gcc-arm-none-eabi 12.2.rel1

=== debian/changelog ===
gcc-arm-none-eabi (15:12.2.rel1-1) unstable; urgency=medium

  * New upstream 12.2.rel1

 -- Keith Packard <keithp@keithp.com>  Thu, 22 Dec 2022 11:50:13 -0800
