## gcc-arm-none-eabi 12.3.rel1

=== debian/changelog ===
gcc-arm-none-eabi (15:12.3.rel1-1) unstable; urgency=medium

  * New upstream 12.3.rel1

 -- Keith Packard <keithp@keithp.com>  Thu, 10 Aug 2023 18:01:27 -0700
