## gcc-arm-none-eabi 13.2.rel1

=== debian/changelog ===
gcc-arm-none-eabi (15:13.2.rel1-2) unstable; urgency=medium

  * Add upstream pacbti fix for v8.1m targets

 -- Keith Packard <keithp@keithp.com>  Mon, 19 Feb 2024 12:04:42 -0800

gcc-arm-none-eabi (15:13.2.rel1-1) unstable; urgency=medium

  * New upstream 13.2.rel1

 -- Keith Packard <keithp@keithp.com>  Thu, 18 Jan 2024 13:16:47 -0800
