=== debian/watch ===
version=4

opts="repack" \
https://developer.arm.com/open-source/gnu-toolchain/gnu-rm/downloads \
    .*@PACKAGE@@ANY_VERSION@-update-src@ARCHIVE_EXT@.* \
    debian debian/repack-upstream.py
