## gcc-arm-none-eabi 14~bpo8+1

=== debian/changelog ===
gcc-arm-none-eabi (14~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Agustin Henze <tin@debian.org>  Thu, 21 May 2015 18:28:36 -0300
