## gcc-arm-none-eabi 14.2.rel1

=== debian/changelog ===
gcc-arm-none-eabi (15:14.2.rel1-1) unstable; urgency=medium

  * New upstream 14.2.rel1

 -- Keith Packard <keithp@keithp.com>  Mon, 13 Jan 2025 22:04:18 -0800
