=== debian/tests/control ===
Tests: build-examples
Restrictions:
    allow-stderr
Depends: @,
 libstdc++-arm-none-eabi-newlib,
