## gcc-arm-none-eabi 15.2.rel1.1

=== debian/changelog ===
gcc-arm-none-eabi (15:15.2.rel1.1-3) unstable; urgency=medium

  * Skip running aarch64 tests on 32-bit targets.

 -- Keith Packard <keithp@keithp.com>  Fri, 13 Feb 2026 08:11:35 -0800

gcc-arm-none-eabi (15:15.2.rel1.1-2) unstable; urgency=medium

  * Make debian tests work again. (Closes: #1127739)

 -- Keith Packard <keithp@keithp.com>  Thu, 12 Feb 2026 12:56:36 -0800

gcc-arm-none-eabi (15:15.2.rel1.1-1) unstable; urgency=medium

  * Ignore lintian errors related to test elf files
  * Remove non-DFSG documentation

 -- Keith Packard <keithp@keithp.com>  Mon, 26 Jan 2026 21:55:46 -0800

gcc-arm-none-eabi (15:15.2.rel1-1) unstable; urgency=medium

  * New upstream 15.2.rel1
  * Build gcc-arch-none-elf too

 -- Keith Packard <keithp@keithp.com>  Sun, 11 Jan 2026 07:17:30 -0800

gcc-arm-none-eabi (15:14.2.rel1-2) unstable; urgency=medium

  * Add picolibc support to the sources
  * Add patches from Zephyr toolchain
  * Add --enable-multilib-space for -Os/-O2 variants of each multilib

 -- Keith Packard <keithp@keithp.com>  Wed, 03 Dec 2025 11:03:12 -0800
