=== debian/tests/control ===
Tests: build-examples
Restrictions:
    allow-stderr
Depends: @,
 picolibc-arm-none-eabi,
 picolibc-aarch64-none-elf,
 libstdc++-arm-none-eabi,
 libstdc++-aarch64-none-elf,
 qemu-system-arm,
 ipxe-qemu
